/* Copyright (C) 2008, Cyril Hu (cyrilhu@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

#if defined(STR_DEBUG) || defined(STR_STRREV_DEBUG)
#include <stdio.h>
#include <string.h>
#endif

/* Place src in reversed order, return a pointer to changed src. */
char *strrev(char *src)
{
	char t, *p = src, *q = src;
	
	for(; *q; ++q) /* no need to use strlen(). */
		;
	while(p < --q) 
		t = *p, *p++ = *q, *q = t;

	return src;
}

#ifdef STR_STRREV_DEBUG
int main(void)
{
	char buf[512]="strrev, place string in reversed order.";
	puts(strrev(buf));
	puts(strrev(buf));
	strcpy(buf, "");
	puts(strrev(buf));
	puts(strrev(buf));
	return 0;
}
#endif
